#!/usr/bin/env python

import DecisionTree
import sys

training_datafile = "training.dat"

dt = DecisionTree.DecisionTree( training_datafile = training_datafile,
                                entropy_threshold = 0.1,
                                max_depth_desired = 3,
                                debug1 = 1,                          
                                debug2 = 1,
                              )
dt.get_training_data()

#   UNCOMMENT THE FOLLOWING LINE if you would like to see the training
#   data that was read from the disk file:
#dt.show_training_data()

root_node = dt.construct_decision_tree_classifier()

#   UNCOMMENT THE FOLLOWING LINE if you would like to see the decision
#   tree displayed in your terminal window:
#root_node.display_decision_tree("   ")

test_sample = ['exercising=>never', 
               'smoking=>heavy', 
               'fatIntake=>heavy',
               'videoAddiction=>heavy']

classification = dt.classify(root_node, test_sample)

which_classes = list( classification.keys() )
which_classes = sorted(which_classes, key=lambda x: classification[x], reverse=True)
print("\nClassification:\n")
for which_class in which_classes:
    print("     "  + str.ljust(which_class, 20) + "  =>  "  + str(classification[which_class]))

print("\n\n")

print("Number of nodes created: ", root_node.how_many_nodes())


